
Redmine - Feature #1248

New Permission:  Edit own issues

2008-05-16 16:54 - Ronie Henrich

Status: Closed Start date: 2008-05-16

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Permissions and roles Estimated time: 0.00 hour

Target version: 4.1.0   

Resolution: Fixed   

Description

Today (as in version 0.7.1):

We may only grant/revoke a role the permission to edit any issues ("Edit issues" permission).

Suggestion / Request:

It would be nice to be able to grant/revoke a role the permission to "Edit own issues".

Related issues:

Related to Redmine - Patch #7444: Patch for improved issue edit permissions Closed 2011-01-25

Related to Redmine - Feature #5195: edit_own_issues and delete_own_issues per... New 2010-03-26

Related to Redmine - Feature #29935: Edit authored issues and Edit assigned i... New

Related to Redmine - Defect #39493: Role with only :edit_own_issues no longer... Confirmed

Has duplicate Redmine - Feature #8805: Please consider to make a new permissi... Closed 2011-07-13

Has duplicate Redmine - Feature #6194: Edit own issues Closed 2010-08-23

Has duplicate Redmine - Feature #4767: Add permission group to allow 'edit yo... Closed 2010-02-08

Associated revisions

Revision 18081 - 2019-04-25 07:32 - Go MAEDA

New Permission: Edit own issue (#1248).

Patch by Yuichi HARADA.

Revision 18082 - 2019-04-25 07:36 - Go MAEDA

Update locales (#1248).

History

#1 - 2008-11-11 10:36 - Jean-Philippe Lang

- Target version deleted (0.8)

#2 - 2009-05-18 17:59 - Daniel Jones

+1

#3 - 2010-05-14 23:50 - Royce Williams

+1.  Empowering users to modify their own request can reduce the load on the people processing requests.

#4 - 2010-08-19 06:45 - Алексей Лошкарёв

+1 This may reduce count of misspelled or invalid bug. Because user may do mistake on filling bug.

#5 - 2010-10-08 05:41 - Leo Hourvitz

- File 0001-Added-edit_own_issues-and-edit_own_new_issues-permis.patch added

I have a patch for this against recent trunk, attached.  We are having this problem in a big way at an installation of mostly native Japanese speakers;

with Asian languages, you're always hitting return to do Kanji conversion of your input and one extra carriage return means a half-baked issue in the

tracker!
New Permissions

I addressed this by creating two new permissions that can be assigned to roles:

edit_own_issues allows users with that permission to edit issues they created (i.e., whose author field is equal to the current user).  This

addresses the problem, but is potentially a big workflow change, so not all sites might want it.

edit_own_new_issues is a more limited permission that allows a user to edit their own issues if there are no journals yet, or if all existing journals

were created by the author.  I think this is really the pinpoint solution to the problem; as far as I know, all edits will create a journal, so this lets

you edit your issue until the moment someone else pays attention to it.

Because it seems like such a contained right, in the patch I added it to the default permissions for the Reporter role.

Implementation

To implement the above, I created a new editable? predicate on the issue model parallel to the visible? predicate that was already there (this also

seems like a pretty good pattern to follow in general).  Then, I changed the code that was doing

User.current.allowed_to?(:edit_issues, @project)

to just call

issue.editable?

instead.

I updated the English and Japanese locales as well.

The patch file was formatted with git format-patch; is that the preferred patch format?  Specifically, the patch was generated against

svn+ssh://rubyforge.org/var/svn/redmine/trunk@4175 e93f8b46-1217.

I'm fairly new to Redmine and Ruby, so it would definitely be good to get other eyes on this patch. I'll be able to get in some more testing next week. 

My configuration is:

bash-3.2$ RAILS_ENV=production ruby script/about

About your application's environment

Ruby version              1.8.7 (universal-darwin10.0)

RubyGems version          1.3.5

Rack version              1.0

Rails version             2.3.5

Active Record version     2.3.5

Active Resource version   2.3.5

Action Mailer version     2.3.5

Active Support version    2.3.5

Application root          /Users/leo/OpenSrcSources/redmine

Environment               production

Database adapter          mysql

Database schema version   20100819172912

#6 - 2010-10-13 17:08 - Leo Hourvitz

I also applied this patch on our production redmine at work (Redmine 1.0.1 release on CentOS 5.2).

#7 - 2010-11-19 02:43 - Nathan Eggen

+1 - this should go in the trunk.

#8 - 2011-01-19 10:13 - Bernhard Furtmueller

+1

#9 - 2011-01-25 19:45 - Brian Lindahl

Created patch issue to follow the progression of my patch to add this feature and other issue edit permission improvements. Please add relation to 

#7444.

#10 - 2011-02-04 03:42 - Leo Hourvitz

Is there any approved way to urge this get moved to trunk?  I need to apply this on every Redmine instance we use, I think any installation with real

scale of users is unmanageable without something like this.

Brian:  I don't seem to have permissions to add the relation.

#11 - 2011-02-08 19:54 - Brian Lindahl

Leo: Issue relations in Redmine are controlled by a different permission: 'Manage issue relations'. I can see a situation where project

managers/software leads would not want issue reporters to have the ability to set up relations. Perhaps another permission should be added:

'Manage own issue relations'?

#12 - 2011-02-08 19:58 - Brian Lindahl
Leo: Hah! Just realized that you were saying that you don't have the permissions to relate this issue to my patch issue #7444.

#13 - 2011-07-13 19:05 - Etienne Massip

- Target version set to Candidate for next major release

#14 - 2012-01-05 17:13 - Gokay Gok

+1

#15 - 2012-01-14 18:45 - Aleksej Lebedev

+1

#16 - 2012-02-22 09:50 - Yannick Recht

+1 also.

It should be interesting to add this parameter.

#17 - 2012-06-18 23:28 - Gabriel Mazetto

It's also wise to have a "time limit" to help people not trying to modify something made a year ago, for example. As we will never find a good for

everyone value, it's good to have it configurable, some values as suggestion:

Limit own issue editing and own issue comments:

Custom (please specify)

30 days

15 days

7 days

3 days

24 hours

12 hours

6 hours

3 hours

less then one hour

Never

#18 - 2012-09-19 10:46 - Rolf Bagge

+1

#19 - 2012-09-20 18:57 - Bruno Passos

+1

#20 - 2012-11-21 17:44 - Thierry Brochu

This would be an excellent feature to allow our client to edit the mistakes on its own created issues without having us to deal with it through a note left

on this same issue by him. +1

#21 - 2012-11-21 21:19 - Terence Mill

+1 - very useful for redmine.org itself

#22 - 2013-09-26 22:44 - Anonymous

+1 crucial

#23 - 2014-01-20 09:23 - Florian Kaiser

+1

#24 - 2014-03-31 15:13 - Alain V.

+1 please for 3.0.0

#25 - 2014-08-03 08:00 - Alain V.

A feature that we should have, please!

#26 - 2014-08-03 09:24 - Etienne Massip

- Has duplicate Feature #6194: Edit own issues added
#27 - 2014-09-01 05:33 - Toshi MARUYAMA

- Related to Feature #5195: edit_own_issues and delete_own_issues permissions added

#28 - 2014-12-01 13:21 - Alain V.

+1 please

#29 - 2015-02-20 08:17 - Oleg Aksenov

+1

#30 - 2015-02-20 21:35 - Omer Arslan

+1 - will be very useful

#31 - 2015-03-09 16:44 - Guillaume Laneel

+1 will be usefull

#32 - 2015-03-09 16:48 - Sandro De Melis

+1 this would be an excellent feature

#33 - 2015-04-21 18:31 - 4wk_ _

+1, really need this. "Editing issue" grant ppl to be like an admin ! (and we don't want that, we want "Edit own issue")

#34 - 2015-05-13 07:41 - Chet Wang

+100

I really need this feature. We're planning to use Redmine but the lack of this feature blocks a lot.

#35 - 2015-06-11 10:31 - Do Lam

+100. We need this permission.

Thank so much!

#36 - 2015-07-17 19:55 - Alexander Lyzhenkov

+100 v 3.1

#37 - 2015-07-27 12:11 - Trurl McByte

+100500 It's bad idea to give access to edit all issues for Reporter only for possibility to change Status from Resolved to Closed

#38 - 2015-11-03 20:33 - Adnan Topçu

Leo Hourvitz's edit_own_new_issues is good idea.

edit_own_issues is topic of this issue.

edit assigned issues is most important for me

In my opinion, "own" is not clear for this mean. Reported or created is more understable ?

#39 - 2015-11-03 20:40 - budo kaiman

+1 to separate "Edit Reported Issues" and "Edit Assigned Issues".

#40 - 2015-11-03 22:04 - Ronie Henrich

Adnan Topçu wrote:

Leo Hourvitz's edit_own_new_issues is good idea.

edit_own_issues is topic of this issue.

edit assigned issues is most important for me

In my opinion, "own" is not clear for this mean. Reported or created is more understable ?

 Owner == Author all accross Redmine, modifying this Redmine convention is out of this issue's scope.

#41 - 2015-11-03 22:20 - Ronie Henrich

budo kaiman wrote:
+1 to separate "Edit Reported Issues" and "Edit Assigned Issues".

In regards to "Edit Reported Issues", please read my comment 40 (#1248#note-40) above;

If a user belongs to a role with "Issues can be assigned to this role" enabled, having something like "Edit Assigned Issues" is not gonna stop

him/her to edit an issue, it is just a matter of assigning the issue to himself/herself and voila, now he/she may edit the issue.

#42 - 2015-11-04 13:10 - budo kaiman

Ronie Henrich wrote:

If a user belongs to a role with "Issues can be assigned to this role" enabled, having something like "Edit Assigned Issues" is not gonna

stop him/her to edit an issue, it is just a matter of assigning the issue to himself/herself and voila, now he/she may edit the issue.

 That only works if they already have "Edit Issues" permission, if they don't have that permission then they cannot assign an issue to themself,

someone else with that permission must assign the issue to them.

Ronie Henrich wrote:

Owner == Author all accross Redmine, modifying this Redmine convention is out of this issue's scope.

 I don't think that there is any scope change, just a wording change as "Author" or "Reporter" is more clear in it's intention.

#43 - 2016-09-24 13:49 - Yuuki NARA

+1

#44 - 2016-12-28 21:34 - Pasi Karkkainen

Yes please, this is an important feature to have!

#45 - 2017-01-27 23:08 - José Campos

+1

#46 - 2017-10-06 06:35 - Eugene Belford

must have feature indeed

#47 - 2018-11-08 15:28 - Go MAEDA

- Related to Feature #29935: Edit authored issues and Edit assigned issues in issue tracking permission added

#48 - 2019-02-03 06:17 - Go MAEDA

- Has duplicate Feature #4767: Add permission group to allow 'edit your own tickets (header)'. added

#49 - 2019-02-20 02:58 - Yuichi HARADA

- File add_permit_edit_own_issues@2x.png added

- File 1248-edit-own-issues-permit.patch added

Added "Edit own issues" permission. This permission can edit issues created by you regardless of the presence or absence of a journal.

I attached a patch.

 add_permit_edit_own_issues@2x.png 

#50 - 2019-04-23 17:40 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

LGTM. Setting the target version to 4.1.0.

#51 - 2019-04-25 07:34 - Go MAEDA

- Subject changed from Permissions - Edit own issues to New Permission:  Edit own issues

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

2025-07-12 5/6

https://www.redmine.org/issues/1248#note-40


#52 - 2023-11-01 23:17 - Mischa The Evil

- Related to Defect #39493: Role with only :edit_own_issues no longer considered for workflow added

Files

0001-Added-edit_own_issues-and-edit_own_new_issues-permis.patch5.88 KB 2010-10-08 Leo Hourvitz

add_permit_edit_own_issues@2x.png 72.4 KB 2019-02-20 Yuichi HARADA

1248-edit-own-issues-permit.patch 6.38 KB 2019-02-20 Yuichi HARADA
